#ifndef __DEFINE_H__
#define __DEFINE_H__

#ifdef __KERNEL__
    #include <linux/types.h>
#else
    #include <sys/types.h>
    #include <stdint.h>
    #include <wchar.h>
#endif // __KERNEL__

#pragma pack(push, 1)

#define UINT64          uint64_t
#define UINT32          uint32_t
#define UINT16          uint16_t
#define UINT8           uint8_t

#define INT64           int64_t
#define INT32           int32_t
#define INT16           int16_t
#define INT8            int8_t

#define QWORD           UINT64
#define DWORD           UINT32
#define WORD            UINT16
#define BYTE            UINT8

#define CHAR            UINT8
#define CHAR8           UINT8
#define CHAR16          UINT16
#define BOOLEAN         bool

#define UINTN           UINT64
#define INTN            INT64

#define USHORT          UINT16
#define PUSHORT         UINT16*
#define ULONG           UINT32
#define PULONG          UINT32*
#define VOID            void
#define PVOID           void*
#define UCHAR           UINT8
#define PUCHAR          UINT8*

#define BIT0            0x00000001
#define BIT1            0x00000002
#define BIT2            0x00000004
#define BIT3            0x00000008
#define BIT4            0x00000010
#define BIT5            0x00000020
#define BIT6            0x00000040
#define BIT7            0x00000080
#define BIT8            0x00000100
#define BIT9            0x00000200
#define BIT10           0x00000400
#define BIT11           0x00000800
#define BIT12           0x00001000
#define BIT13           0x00002000
#define BIT14           0x00004000
#define BIT15           0x00008000
#define BIT16           0x00010000
#define BIT17           0x00020000
#define BIT18           0x00040000
#define BIT19           0x00080000
#define BIT20           0x00100000
#define BIT21           0x00200000
#define BIT22           0x00400000
#define BIT23           0x00800000
#define BIT24           0x01000000
#define BIT25           0x02000000
#define BIT26           0x04000000
#define BIT27           0x08000000
#define BIT28           0x10000000
#define BIT29           0x20000000
#define BIT30           0x40000000
#define BIT31           0x80000000

#pragma pack(pop)

#endif // __DEFINE_H__
